data:
  - {_id: 1, x: 11}
  - {_id: 2, x: 22}
  - {_id: 3, x: 33}
  - {_id: 4, x: 44}

collection_name: &collection_name 'Bulkwrite_update_hint'

tests:
  -
    description: "Unacknowledged bulkWrite updateOne with hints fails with client-side error"
    operations:
      -
        name: "bulkWrite"
        collectionOptions: &collection_options
          writeConcern: { w: 0 }
        arguments:
          requests:
            -
              name: "updateOne"
              arguments:
                filter: &updateOne_filter { _id: 1 }
                update: &updateOne_update { $inc: { x: 1 } }
                hint: &hint_string "_id_"
            -
              name: "updateOne"
              arguments:
                filter: *updateOne_filter
                update: *updateOne_update
                hint: &hint_doc { _id: 1 }
          options: { ordered: true }
        error: true
    expectations: []
    outcome: &outcome
      collection:
        data:
          - {_id: 1, x: 11 }
          - {_id: 2, x: 22 }
          - {_id: 3, x: 33 }
          - {_id: 4, x: 44 }
  -
    description: "Unacknowledged bulkWrite updateMany with hints fails with client-side error"
    operations:
      -
        name: "bulkWrite"
        collectionOptions: *collection_options
        arguments:
          requests:
            -
              name: "updateMany"
              arguments:
                filter: &updateMany_filter { _id: { $lt: 3 } }
                update: &updateMany_update { $inc: { x: 1 } }
                hint: *hint_string
            -
              name: "updateMany"
              arguments:
                filter: *updateMany_filter
                update: *updateMany_update
                hint: *hint_doc
          options: { ordered: true }
        error: true
    expectations: []
    outcome: *outcome
  -
    description: "Unacknowledged bulkWrite replaceOne with hints fails with client-side error"
    operations:
      -
        name: "bulkWrite"
        collectionOptions: *collection_options
        arguments:
          requests:
            -
              name: "replaceOne"
              arguments:
                filter: { _id: 3 }
                replacement: { x: 333 }
                hint: *hint_string
            -
              name: "replaceOne"
              arguments:
                filter: { _id: 4 }
                replacement: { x: 444 }
                hint: *hint_doc
          options: { ordered: true }
        error: true
    expectations: []
    outcome: *outcome
